C..   EXAMPLE 1
C..   CAPITAL ACCUMULATION
C..
      IMPLICIT REAL*8(A-H,O-Z)
C.. DIMENSION OF PROBLEM
      PARAMETER (N=2,N1=N+1)
C.. DECLARATIONS
      PARAMETER (LRWORK=99999,LIWORK=99999)
      DIMENSION XEQUI(N),X(N1),X0(N),I0(N)
      DIMENSION RWORK(LRWORK),IWORK(LIWORK)
C.. INITIAL GUESS FOR EQUILIBRIUM
      XEQUI(1)=20.0D0
      XEQUI(2)= 1.0D0
C.. PARAMETER FOR TRANSFORMATION TO FINITE INTERVAL
C        (SET TO ZERO FOR INTERNAL CHOICE)
      R=0.D0
C.. INITIAL CONDITIONS IN ORDER OF IMPORTANCE (CODE SELECTS FIRST NS CONDITIONS)
      I0(1)=1
      X0(I0(1))=1.0D0
C.. REQUIRED TOLERANCE
      TOL=1.D-7
C.. CUT IN EIGENVALUE TREATMENT
      CUT=1.D-12
C.. PRINT PARAMETER
C        (0: NO OUTPUT/1: SMALL OUTPUT/2: LARGE OUTPUT)
      KPRINT=2
C.. OUTPUT UNIT
      OPEN (UNIT=6,FILE='ex1.out')
C.. CALL OF DRIVER
      CALL OPTTRJ(N,XEQUI,X0,I0,R,TOL,CUT,KPRINT,IERR,
     &   RWORK,LRWORK,IWORK,LIWORK)
C.. OUTPUT OF SOLUTION TRAJECTORY
      IF (IERR.NE.0) STOP
      WRITE(6,60900)
60900 FORMAT(/'SOLUTION PROFILE')
      NOUT=100
      WRITE(6,60901) 0.D0,XEQUI(1),XEQUI(2)
      RATIO=1.D0/NOUT
      DO 900 IOUT=1,NOUT
      S=IOUT*RATIO
      CALL APPSLN(S,X,RWORK,IWORK)
      WRITE(6,60901) S,X(1),X(2)
60901 FORMAT(3D18.10)
  900 CONTINUE
      STOP
      END
C
C
      SUBROUTINE FEVAL(N,X,F)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(N),F(N)
      DATA ALPHA,DELTA/0.03D0,0.07D0/
      F(1)=X(2)/2.D0-ALPHA*X(1)
      F(2)=X(2)*(ALPHA+DELTA)-1.D0/(2.D0*DSQRT(X(1)))
      RETURN
      END
C
C
      SUBROUTINE JEVAL(N,L,X,DFDX)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(N),DFDX(L,N)
      DATA ALPHA,DELTA/0.03D0,0.07D0/
      DFDX(1,1)=-ALPHA
      DFDX(1,2)=0.5D0
      DFDX(2,1)=1.D0/(4.D0*DSQRT(X(1)**3))
      DFDX(2,2)=ALPHA+DELTA
      RETURN
      END
