C..   EXAMPLE 2 
C..   HARVESTING IN A MULTI-SPECIES ENVIRONMENT 
C.. 
      IMPLICIT REAL*8(A-H,O-Z) 
C.. DIMENSION OF PROBLEM 
      PARAMETER (N=4,N1=N+1) 
C.. DECLARATIONS 
      PARAMETER (LRWORK=99999,LIWORK=99999) 
      DIMENSION XEQUI(N),X(N1),X0(N),I0(N) 
      DIMENSION RWORK(LRWORK),IWORK(LIWORK) 
C.. PARAMETER FOR USER-DEFINED FUNCTION 
      REAL*8 ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      COMMON/PARA/ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      DIMENSION PARAM(3) 
      PARAM(1)= 0.5D0 
      PARAM(2)= 0.0D0 
      PARAM(3)=-0.5D0 
C.. OUTPUT UNIT 
      OPEN (UNIT=6,FILE='ex2.out') 
C.. LOOP: PREDATOR GENERATES POSITIVE, NO, NEGATIVE BENEFIT 
      DO 800 I=1,3 
      A=PARAM(I) 
C.. INITIAL GUESS FOR EQUILIBRIUM 
      XEQUI(1)= 0.16D0 
      XEQUI(2)= 0.44D0 
      XEQUI(3)= 7.9D0 
      XEQUI(4)=-0.63D0 
C.. PARAMETER FOR TRANSFORMATION TO FINITE INTERVAL 
C        (SET TO ZERO FOR INTERNAL CHOICE) 
      R=0.D0 
C.. INITIAL CONDITIONS IN ORDER OF IMPORTANCE (CODE SELECTS FIRST NS CONDITIONS) 
      I0(1)=1 
      X0(I0(1))=0.175D0 
      I0(2)=2 
      X0(I0(2))=0.5625D0 
C.. REQUIRED TOLERANCE 
      TOL=1.D-7 
C.. CUT IN EIGENVALUE TREATMENT 
      CUT=1.D-12 
C.. PRINT PARAMETER 
C        (0: NO OUTPUT/1: SMALL OUTPUT/2: LARGE OUTPUT) 
      KPRINT=2 
C.. CALL OF DRIVER 
      CALL OPTTRJ(N,XEQUI,X0,I0,R,TOL,CUT,KPRINT,IERR, 
     &   RWORK,LRWORK,IWORK,LIWORK) 
C.. OUTPUT OF SOLUTION TRAJECTORY 
      IF (IERR.NE.0) STOP 
      WRITE(6,60900) 
60900 FORMAT(/'SOLUTION PROFILE') 
      NOUT=100 
      WRITE(6,60901) 0.D0,XEQUI(1),XEQUI(2),XEQUI(3),XEQUI(4) 
      RATIO=1.D0/NOUT 
      DO 900 IOUT=1,NOUT 
      S=IOUT*RATIO 
      CALL APPSLN(S,X,RWORK,IWORK) 
      WRITE(6,60901) S,X(1),X(2),X(3),X(4) 
60901 FORMAT(5D18.10) 
  900 CONTINUE 
  800 CONTINUE 
      STOP 
      END 
C 
C 
      BLOCKDATA 
      REAL*8 ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      COMMON/PARA/ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      DATA ALPHAA,BETAA,GAMMAA/2.0D0,5.0D0,-1D0/ 
      DATA ALPHAB,BETAB,GAMMAB/1.0D0,8.0D0,20.0D0/ 
      DATA DELTA/0.05D0/ 
      END 
C 
C 
      SUBROUTINE FEVAL(N,X,F) 
      IMPLICIT REAL*8(A-H,O-Z) 
      REAL*8 X(N),F(N) 
      REAL*8 ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      COMMON/PARA/ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      F(1) = X(1)*(ALPHAA - X(1)*BETAA + X(2)*GAMMAA) + 
     $     (X(3) - DSQRT(8D0 + X(3)**2))/4D0 
      F(2) = X(2)*(ALPHAB - X(2)*BETAB + X(1)*GAMMAB) + X(4)/2D0 
      F(3) = -1/X(1) - 
     $     (ALPHAA-2*BETAA*X(1)+X(2)*GAMMAA)*X(3) 
     $ + DELTA*X(3) - X(2)*GAMMAB*X(4) 
      F(4) = -A - X(1)*GAMMAA*X(3) - 
     $     (ALPHAB - 2*X(2)*BETAB + X(1)*GAMMAB)*X(4) + DELTA*X(4) 
      RETURN 
      END 
C 
C 
      SUBROUTINE JEVAL(N,L,X,DFDX) 
      IMPLICIT REAL*8(A-H,O-Z) 
      REAL*8 X(N),DFDX(L,N) 
      REAL*8 ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      COMMON/PARA/ALPHAA,BETAA,GAMMAA,ALPHAB,BETAB,GAMMAB,DELTA,A 
      DFDX(1,1)=ALPHAA - 2*X(1)*BETAA + X(2)*GAMMAA 
      DFDX(1,2)=GAMMAA*X(1) 
      DFDX(1,3)=(1D0-X(3)/DSQRT(8D0+X(3)**2))/4 
      DFDX(1,4)=0.D0 
      DFDX(2,1)=GAMMAB*X(2) 
      DFDX(2,2)=ALPHAB-2*X(2)*BETAB+GAMMAB*X(1) 
      DFDX(2,3)=0.D0 
      DFDX(2,4)=0.5D0 
      DFDX(3,1)=1/X(1)**2+2*BETAA*X(3) 
      DFDX(3,2)=-GAMMAA*X(3)-GAMMAB*X(4) 
      DFDX(3,3)=-ALPHAA+2*X(1)*BETAA-GAMMAA*X(2)+DELTA 
      DFDX(3,4)=-GAMMAB*X(2) 
      DFDX(4,1)=-GAMMAA*X(3)-GAMMAB*X(4) 
      DFDX(4,2)=2*BETAB*X(4) 
      DFDX(4,3)=-GAMMAA*X(1) 
      DFDX(4,4)=-ALPHAB+2*X(2)*BETAB-GAMMAB*X(1)+DELTA 
      RETURN 
      END 
